

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable DBNameList ""
    variable DBName ""

   variable index 0
   variable selected 0


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected
        variable DBName
        variable ::VMEConfig::ModuleName
        variable ::VMEConfig::NumModules
        variable ::VMEAccessServer::DBRootName
        variable ::VMEAccessServer::DBNodeBase

        set RootName $::VMEAccessServer::DBRootName
        set NodeBase $::VMEAccessServer::DBNodeBase

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=$selected"
        InsertLog "DBName=$DBName"

        InsertLog "HasBeenConfigured = [::VMEConfig::ReadRegister HasBeenConfigured]"
        InsertLog "HasBeenRestored = [::VMEConfig::ReadRegister HasBeenRestored]"

        InsertLog "DBRootName = $RootName"
        InsertLog "DBNodeBase = $NodeBase"
   }

      proc Selection {} {
          variable selected

          set selected 0

          if {![info exists ::VMEConfig::NumModules]} return

           for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
               if {[set ::VMEConfig::ModuleType($i)] != ""} {set selected [expr $selected | (1 << $i)]}
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }
  
      proc do_Save {} {
        variable JS
        variable selected
        variable ::VMEConfig::ModuleName
        variable ::VMEConfig::NumModules
        variable ::VMEAccessServer::DBRootName
        variable ::VMEAccessServer::DBNodeBase
        
        set RootName $::VMEAccessServer::DBRootName
        set NodeBase $::VMEAccessServer::DBNodeBase

         if {$selected == 0} {Selection}
      
        EmptyLog
        InsertLog "Saving VME settings to $RootName/$NodeBase"
        
          for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
             if {[expr ($selected >> $i) & 1] == 0} {continue}
             set moduleindex [second [split [set ::VMEConfig::ModuleName($i)] #]]
             switch [set ::VMEConfig::ModuleType($i)] {
                 CAEN_V785  {::V785::do_Save  $moduleindex}
                 CAEN_V775  {::V775::do_Save  $moduleindex}
                 CAEN_V1724 {::V1724::do_Save $moduleindex}
                 CAEN_V1724DPP {::V1724DPP::do_Save $moduleindex}
                 CAEN_DT5780 {::DT5780::do_Save $moduleindex}
                 CAEN_V1720 {::V1720::do_Save $moduleindex}
                 CAEN_V1730 {::V1730::do_Save $moduleindex}
                 CAEN_V1740 {::V1740::do_Save $moduleindex}
                 CAEN_V1742 {::V1742::do_Save $moduleindex}
                 CAEN_V1751 {::V1751::do_Save $moduleindex}
                 CAEN_V1751DPP {::V1751DPP::do_Save $moduleindex}
                 CAEN_V1495 {::V1495::do_Save $moduleindex}
                 CAEN_V560  {::V560::do_Save  $moduleindex}
                 CAEN_V830  {::V830::do_Save  $moduleindex}
                 PatternGen {::PatternGen::do_Save $moduleindex}
                 SAC        {}
                 default {}
             }
             InsertLog "VME settings saved for [set ::VMEConfig::ModuleName($i)]"
          }

        InsertLog "VME settings saved to $RootName/$NodeBase"

        set m $JS

        Elog INFORMATION "VME settings saved to $RootName/$NodeBase"

        do_DBUpdate

         return $m
    }

      proc do_Restore {} {
        variable JS
        variable selected
        variable ::VMEConfig::ModuleName
        variable ::VMEConfig::NumModules
        variable ::VMEAccessServer::DBRootName
        variable ::VMEAccessServer::DBNodeBase

        set RootName $::VMEAccessServer::DBRootName
        set NodeBase $::VMEAccessServer::DBNodeBase

    if {![info exists ::VMEConfig::started] || [::VMEConfig::ReadVMERegister HasBeenConfigured] == 0} {
          set html "<script>alert(\"No hardware configuration selected and activated\\nDo this first\");</script>"
          return
    }

         if {$selected == 0} {Selection}

        EmptyLog
        InsertLog "Restoring VME settings from $RootName/$NodeBase"
        
          for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
             if {[expr ($selected >> $i) & 1] == 0} {continue}
             set moduleindex [second [split [set ::VMEConfig::ModuleName($i)] #]]
             switch [set ::VMEConfig::ModuleType($i)] {
                 CAEN_V785  {::V785::do_Restore  $moduleindex}
                 CAEN_V775  {::V775::do_Restore  $moduleindex}
                 CAEN_V1724 {::V1724::do_Restore $moduleindex}
                 CAEN_V1724DPP {::V1724DPP::do_Restore $moduleindex}
                 CAEN_DT5780 {::DT5780::do_Restore $moduleindex}
                 CAEN_V1720 {::V1720::do_Restore $moduleindex}
                 CAEN_V1730 {::V1730::do_Restore $moduleindex}
                 CAEN_V1740 {::V1740::do_Restore $moduleindex}
                 CAEN_V1742 {::V1742::do_Restore $moduleindex}
                 CAEN_V1751 {::V1751::do_Restore $moduleindex}
                 CAEN_V1751DPP {::V1751DPP::do_Restore $moduleindex}
                 CAEN_V1495 {::V1495::do_Restore $moduleindex}
                 CAEN_V560  {::V560::do_Restore  $moduleindex}
                 CAEN_V830  {::V830::do_Restore  $moduleindex}
                 PatternGen {::PatternGen::do_Restore $moduleindex}
                 SAC        {}
                 default {}
             }
             InsertLog "VME settings restored for [set ::VMEConfig::ModuleName($i)]"
          }

        InsertLog "VME settings restored from $RootName/$NodeBase"

         set m $JS

       ::VMEConfig::WriteRegister HasBeenRestored 1

        Elog INFORMATION "VME settings restored from $RootName/$NodeBase"

        do_DBUpdate

       return $m
    }

      proc do_DBName {vl} {
         global Options
         variable DBName

          set ::VMEAccessServer::DBNodeBase $vl
          DBCreateNode $::VMEAccessServer::DBRootName/$::VMEAccessServer::DBNodeBase

          set Options(VME.settings) $vl
          SaveOptions

          set DBName $vl

          InsertLog "Data Base node $::VMEAccessServer::DBRootName/$::VMEAccessServer::DBNodeBase contains [DBGetNodes $::VMEAccessServer::DBRootName/$::VMEAccessServer::DBNodeBase *]"
      }

      proc do_DBUpdate {} {
          variable DBNameList

          set DBNameList {}
          foreach item [DBGetNodes $::VMEAccessServer::DBRootName *] {
              if {$item == "Options"} continue
              lappend DBNameList $item
          }
      }

      proc xxdo_DBName {vl} {
        variable DBName
        variable ::VMEAccessServer::DBRootName
        variable ::VMEAccessServer::DBNodeBase

        set RootName $::VMEAccessServer::DBRootName
        set NodeBase $::VMEAccessServer::DBNodeBase

          set DBName $vl
          set ::VMEAccessServer::DBNodeBase $DBName
          set NodeBase $::VMEAccessServer::DBNodeBase

          set node [set RootName]/[set NodeBase]
          DBCreateNode $node

          InsertLog "Data Base node $node contains [DBGetNodes $node *]"
      }

      proc xxdo_DBUpdate {} {
        variable DBNameList
        variable ::VMEAccessServer::DBRootName
        variable ::VMEAccessServer::DBNodeBase

        set RootName $::VMEAccessServer::DBRootName
        set NodeBase $::VMEAccessServer::DBNodeBase

          set DBNameList [DBGetNodes $RootName *]
      }
    

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                RESTORE  {do_Restore}
                SAVE     {do_Save}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

   Selection

     do_DBUpdate
     do_DBName [lindex $DBNameList 0]


}  ;# end of if {$started == 0}

